//+------------------------------------------------------------------+
//|                                                       StoDiv.mq4 |
//|                                       Copyright 2014, Metaquotes |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Metaquotes"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_minimum    0
#property indicator_maximum    100
#property indicator_buffers    2
#property indicator_color1     clrLightSeaGreen
#property indicator_color2     clrRed
#property indicator_level1     20.0
#property indicator_level2     80.0
#property indicator_levelcolor clrSilver
#property indicator_levelstyle STYLE_DOT

input double Angle=1;
input int KPeriod=5;
input int DPeriod=3;
input int Slowing=3;
input ENUM_MA_METHOD MAMethod=MODE_SMA;
input ENUM_STO_PRICE PriceField=STO_LOWHIGH;
input string Note1="IndicatorMode=0 >> MODE_MAIN";
input string Note2="IndicatorMode=1 >> MODE_SIGNAL";
input int IndicatorMode=MODE_MAIN; 

//--- indicator buffers
double         stocBuffer[];
double         divBuffer[];
double         nodivergence[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,stocBuffer);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexBuffer(1,divBuffer);
   SetIndexArrow(1,167);
   SetIndexBuffer(2,nodivergence);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   ArraySetAsSeries(stocBuffer,true);
   ArraySetAsSeries(divBuffer,true);
   ArraySetAsSeries(close,true);
   ArraySetAsSeries(open,true);
   
   int flag1=0;
   int flag2=0;
   for(int i=0;i<rates_total;i++)
     {
      double cur=iStochastic(Symbol(),Period(),KPeriod,DPeriod,Slowing,MAMethod,PriceField,IndicatorMode,i);
      double pre=iStochastic(Symbol(),Period(),KPeriod,DPeriod,Slowing,MAMethod,PriceField,IndicatorMode,i+1);
      stocBuffer[i]=cur;
      divBuffer[i]=EMPTY_VALUE;
      if(NormalizeDouble(close[i]-open[i],Digits)>0.0)
        {
         if(((cur<=50)&&(cur>=indicator_level1)&&(pre>=cur))||((cur>=50)&&(cur<=indicator_level2)&&(pre<=cur))) continue;
         if(((cur>=indicator_level2)&&(cur>=pre))||((cur<=indicator_level1)&&(cur<=pre))) continue;
         if(cur<=pre-Angle)
           {
            divBuffer[i]=cur;
           }
        }
      if(NormalizeDouble(close[i]-open[i],Digits)<0.0)
        {
         if(((cur<=50)&&(cur>=indicator_level1)&&(pre>=cur))||((cur>=50)&&(cur<=indicator_level2)&&(pre<=cur))) continue;
         if(((cur>=indicator_level2)&&(cur>=pre))||((cur<=indicator_level1)&&(cur<=pre))) continue;
         if(cur>=pre+Angle)
           {
            divBuffer[i]=cur;
           }
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

      
